/*
 * BeaconTorch.h
 *
 *  Created on: Sep 13, 2019
 *      Author: a0222913
 */

#ifndef BEACONTORCH_H_
#define BEACONTORCH_H_

#define DATA_LENGTH_1                (0x00) //00b: Normal Mode;  10b: Burst
#define DATA_LENGTH_2                (0x10) //01b: Bust mode with 2 byte data;
#define DATA_LENGTH_4                (0x20) //10b: Burst mode with 4 byte data;
#define DATA_LENGTH_8                (0x30) //11b: Burst mode with 8 byte data

#define DEV_ADDR_0      (0x00) //device address = 0;
#define DEV_ADDR_1      (0x01) //device address = 1;
#define DEV_ADDR_2      (0x02) //device address = 2;
#define DEV_ADDR_3      (0x03) //device address = 3;
#define DEV_ADDR_4      (0x04) //device address = 4;
#define DEV_ADDR_5      (0x05) //device address = 5;
#define DEV_ADDR_6      (0x06) //device address = 6;
#define DEV_ADDR_7      (0x07) //device address = 7;
#define DEV_ADDR_8      (0x08) //device address = 8;
#define DEV_ADDR_9      (0x09) //device address = 9;
#define DEV_ADDR_10     (0x0A) //device address = 10;
#define DEV_ADDR_11     (0x0B) //device address = 11;
#define DEV_ADDR_12     (0x0C) //device address = 12;
#define DEV_ADDR_13     (0x0D) //device address = 13;
#define DEV_ADDR_14     (0x0E) //device address = 14;
#define DEV_ADDR_15     (0x0F) //device address = 15;

#define UP_BUTTON_CLICK (8)
#define MIDDLE_BUTTON_CLICK (4)
#define LEFT_BOTTOM_BUTTON_CLICK (1)
#define RIGHT_BOTTOM_BUTTON_CLICK (2)

#define FLEX_Write      (0x80) //FlexWire write
#define FLEX_Read       (0x00) //FlexWire read

#define TRUE (0x01)
#define FALSE (0x00)

void crcInitial(); /*Calculate and Store the CRC value of 0x00 to 0xFF for CRC Look-Up-Table method*/
char CRC_LUT(char commandFrame_withoutCRC[], unsigned int byteLength); /*calculate CRC of command frame*/
void icsInitial();

void timerInitial();
void delay(int delayTime); //50 = 1ms
void timeOut(int timeOut); //50 = 1ms

void uartInitial();

void Enable_Interrupt(unsigned char vector_number);
void uartWrite(char commandFrame[], unsigned int frameLength, unsigned int checkResponse, unsigned int responseLength);
void FlexBroadcast(char registerAddr, char DATA_BYTES[], char DATA_LENGTH_x);
void FlexWrite(char DEV_ADDR_x, char registerAddr, char DATA_BYTES[], char DATA_LENGTH_x, unsigned int checkResponse);
void FlexRead(char DEV_ADDR_x, char registerAddr, char DATA_LENGTH_x);

void Turn_Flow(unsigned int mode);
//void Tail_Flow_On();
void Tail_Flow_On(unsigned int interval);
void Tail_All_On();
void Tail_All_Off();
//void Tail_Flow_Off();
void Tail_Flow_Off(unsigned int interval);
//void Greeting_and_Goodbye();
void Greeting_and_Goodbye(unsigned int interval);
void Goodbye(unsigned int interval);
void Greeting_and_Goodbye_update(unsigned int interval);
void Goodbye_update(unsigned int interval);
void All_Off();
void fadeInOUT();
void stopBlink();
void drlBlink();
void setGlobalDC();

void kbiInitial();
void demoEngine(char buttonClick);

#endif /* BEACONTORCH_H_ */
