/*
 * Patterns.c
 *
 *  Created on: Sep 29, 2019
 *      Author: a0222913
 */
#include "BeaconTorch.h"

extern char leftTurnFlag;
extern char rightTurnFlag;
extern char tailAllOnFlag;
extern char tailAllOffFlag;
extern char tailFlowFlag;
extern char taiLGreetingFlag;
extern char tailGoodbyeFlag;
extern char standByFlag;

void Turn_Flow(unsigned int mode)//mode = 0, left turn flow
								 //mode = 1, right turn flow
 	 	 	 	 	 	 	 	 //mode = 2, left and right flow
{
	char data[8];
	char Turn_0_data[12][2]={{0x01, 0x00},{0x03, 0x00},{0x07, 0x00},{0x0F, 0x00},{0x1F, 0x00},{0x3F, 0x00},{0x7F, 0x00},{0xFF, 0x00},{0xFF, 0x01},{0xFF, 0x03},{0xFF, 0x07},{0xFF, 0x0F}};
	//char Turn_12_data[5][2]={{0x40,0x00},{0xC0,0x00},{0xC0,0x01},{0xC0,0x03},{0xC0,0x07}};
	//char Turn_4_data[5][2]={{0x01,0x00},{0x03,0x00},{0x07,0x00},{0x0F,0x00},{0x1F,0x00}};
	unsigned int i=0;

	//***initialize
	data[0]=0x02;	//unlock
	//FlexWrite(DEV_ADDR_8, 0x61, data, DATA_LENGTH_1, TRUE);//unlock device 8
	FlexWrite(DEV_ADDR_0, 0x61, data, DATA_LENGTH_1, TRUE);//unlock device 0
	//FlexWrite(DEV_ADDR_12, 0x61, data, DATA_LENGTH_1, TRUE);//unlock device 12
	//FlexWrite(DEV_ADDR_4, 0x61, data, DATA_LENGTH_1, TRUE);//unlock device 4
	//***clear fault
	data[0]=0x03;	//clear fault
	//FlexWrite(DEV_ADDR_8, 0x60, data, DATA_LENGTH_1, TRUE);//clear fault on device 8
	FlexWrite(DEV_ADDR_0, 0x60, data, DATA_LENGTH_1, TRUE);//clear fault on device 0
	//FlexWrite(DEV_ADDR_12, 0x60, data, DATA_LENGTH_1, TRUE);//clear fault on device 12
	//FlexWrite(DEV_ADDR_4, 0x60, data, DATA_LENGTH_1, TRUE);//clear fault on device 4
	//***turn off all channels on device 8 and 0 and 12 and 4
	data[0]=0x00;
	data[1]=0x00;
	//FlexWrite(DEV_ADDR_8, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all channels on device 8
	FlexWrite(DEV_ADDR_0, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all channels on device 0
	//FlexWrite(DEV_ADDR_12, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all channels on device 12
	//FlexWrite(DEV_ADDR_4, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all channels on device 4;
	//***lock unchanged register
	data[0]=0x0B;	//lock
	//FlexWrite(DEV_ADDR_8, 0x61, data, DATA_LENGTH_1, TRUE);//lock device 8
	FlexWrite(DEV_ADDR_0, 0x61, data, DATA_LENGTH_1, TRUE);//lock device 0
	//FlexWrite(DEV_ADDR_12, 0x61, data, DATA_LENGTH_1, TRUE);//lock device 12
	//FlexWrite(DEV_ADDR_4, 0x61, data, DATA_LENGTH_1, TRUE);//lock device 4

	//***start patterns
	//Turn -> Tail
	i=0;
	do //turn on device 8 and device 0 in turn
	{
		FlexWrite(DEV_ADDR_0, 0x50, Turn_0_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 0
		delay(1000);//delay 20ms
		i++;
	}while(i<12);
	//***keep ON 100ms
	delay(10000);//delay 200ms
	//***turn off all channels on device 8 and 0 and 13 and 5
	data[0]=0x00;
	data[1]=0x00;
	//FlexWrite(DEV_ADDR_8, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all channels on device 8
	FlexWrite(DEV_ADDR_0, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all channels on device 0
	//FlexWrite(DEV_ADDR_12, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all channels on device 12
	//FlexWrite(DEV_ADDR_4, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all channels on device 4
	delay(20000);//delay 400ms
}

void Tail_Flow_On(unsigned int interval)//interval = 50 ---> 1ms
{
	char data[8];
	char Tail_10_2_data[8][2]={{0x10,0x00},{0x30,0x00},{0x70,0x00},{0xF0,0x00},{0xF0,0x01},{0xF0,0x03},{0xF0,0x07},{0xF0,0x0F}};
	char Tail_11_data[5][2]={{0x03,0x00},{0x0F,0x00},{0x3F,0x00},{0xFF,0x00},{0xFF,0x03}};
	//char Tail_11_data[3][2]={{0x3F,0x00},{0xFF,0x00},{0xFF,0x03}};
	char Tail_3_data[5][2]={{0x0C,0x00},{0x3C,0x00},{0xFC,0x00},{0xFC,0x03},{0xFC,0x0F}};
	//char Tail_3_down_data[3][2]={{0xFC,0x00},{0xFC,0x03},{0xFC,0x0F}};
	char Tail_9_data[8][2]={{0x80,0x00},{0xC0,0x00},{0xE0,0x00},{0xF0,0x00},{0xF8,0x00},{0xFC,0x00},{0xFE,0x00},{0xFF,0x00}};
	char Tail_1_data[8][2]={{0x00,0x08},{0x00,0x0C},{0x00,0x0E},{0x00,0x0F},{0x80,0x0F},{0xC0,0x0F},{0xE0,0x0F},{0xF0,0x0F}};
	unsigned int i;

	//***initialize
	data[0]=0x02;	//unlock
	FlexBroadcast(0x61, data, DATA_LENGTH_1);//write 0x02 to 0x61
	//***clear fault
	data[0]=0x03;	//clear fault
	FlexBroadcast(0x60, data, DATA_LENGTH_1);//write 0x03 to 0x60 to clear CLR_POR and CLR_FAULT
	//***turn off all channels
	data[0]=0x00;
	data[1]=0x00;
	FlexBroadcast(0x50, data, DATA_LENGTH_2);//write 0x00 to 0x50 and 0x51
	//***lock unchanged register
	data[0]=0x0B;	//lock
	FlexBroadcast(0x61, data, DATA_LENGTH_1);//write 0x0B to 0x61 to lock CLRLOCK, IOUTLOCK and PWMLOCK

	//***start patterns
	//Tail -> Tail
	i=0;
	do //turn on device 10 and device 2 in turn
	{
		if(tailFlowFlag==0)
		{
			break;
		}
		FlexWrite(DEV_ADDR_10, 0x50, Tail_10_2_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 10
		FlexWrite(DEV_ADDR_2, 0x50, Tail_10_2_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 2
		delay(interval);
		i++;
	}while(i<8);
	i=0;
	do //turn on device 11 and device 3 in turn
	{
		if(tailFlowFlag==0)
		{
			break;
		}
		FlexWrite(DEV_ADDR_11, 0x50, Tail_11_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 11
		FlexWrite(DEV_ADDR_3, 0x50, Tail_3_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 3
		delay(interval);
		i++;
	}while(i<5);
	i=0;
	do //turn on device 9 and device 1 in turn
	{
		if(tailFlowFlag==0)
		{
			break;
		}
		FlexWrite(DEV_ADDR_9, 0x50, Tail_9_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 9
		FlexWrite(DEV_ADDR_1, 0x50, Tail_1_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 1
		delay(interval);
		i++;
	}while(i<8);
	//***keep ON 10ms
	if(tailFlowFlag==1)
	{
		delay(20000);//delay 400ms
	}
	//***turn off all channels
	data[0]=0x00;
	data[1]=0x00;
	FlexBroadcast(0x50, data, DATA_LENGTH_2);//write 0x00 to 0x50 and 0x51
	if(tailFlowFlag==1)
	{
		delay(20000);//delay 400ms
	}
}

void Tail_All_On()
{
	char data[8];
	char Tail_10_2_all_on_data[2]={0xF0,0x0F};
	char Tail_11_all_on_data[2]={0xFF,0x03};
	char Tail_3_all_on_data[2]={0xFC,0x0F};
	char Tail_9_all_on_data[2]={0xFF,0x00};
	char Tail_1_all_on_data[2]={0xF0,0x0F};

	//***initialize
	data[0]=0x02;	//unlock
	FlexBroadcast(0x61, data, DATA_LENGTH_1);//write 0x02 to 0x61
	//***clear fault
	data[0]=0x03;	//clear fault
	FlexBroadcast(0x60, data, DATA_LENGTH_1);//write 0x03 to 0x60 to clear CLR_POR and CLR_FAULT
	//***lock unchanged register
	data[0]=0x0B;	//lock
	FlexBroadcast(0x61, data, DATA_LENGTH_1);//write 0x0B to 0x61 to lock CLRLOCK, IOUTLOCK and PWMLOCK
	//***turn on all channels
	FlexWrite(DEV_ADDR_10, 0x50, Tail_10_2_all_on_data, DATA_LENGTH_2, TRUE);//turn on all used channels on device 10
	FlexWrite(DEV_ADDR_2, 0x50, Tail_10_2_all_on_data, DATA_LENGTH_2, TRUE);//turn on all used channels on device 2
	FlexWrite(DEV_ADDR_11, 0x50, Tail_11_all_on_data, DATA_LENGTH_2, TRUE);//turn on all used channels on device 11
	FlexWrite(DEV_ADDR_3, 0x50, Tail_3_all_on_data, DATA_LENGTH_2, TRUE);//turn on all used channels on device 3
	FlexWrite(DEV_ADDR_9, 0x50, Tail_9_all_on_data, DATA_LENGTH_2, TRUE);//turn on all used channels on device 9
	FlexWrite(DEV_ADDR_1, 0x50, Tail_1_all_on_data, DATA_LENGTH_2, TRUE);//turn on all used channels on device 1
	//delay(25000);//delay 500ms
}

void All_Off()
{
	char data[8];
	//***initialize
	data[0]=0x02;	//unlock
	FlexBroadcast(0x61, data, DATA_LENGTH_1);//write 0x02 to 0x61
	//***clear fault
	data[0]=0x03;	//clear fault
	FlexBroadcast(0x60, data, DATA_LENGTH_1);//write 0x03 to 0x60 to clear CLR_POR and CLR_FAULT
	//***turn off all channels
	data[0]=0x00;
	data[1]=0x00;
	FlexBroadcast(0x50, data, DATA_LENGTH_2);
	//***lock unchanged register
	data[0]=0x0B;	//lock
	FlexBroadcast(0x61, data, DATA_LENGTH_1);//write 0x0B to 0x61 to lock CLRLOCK, IOUTLOCK and PWMLOCK
}

void Tail_All_Off()
{
	char data[2]={0x00,0x00};

	//***initialize
	data[0]=0x02;	//unlock
	FlexBroadcast(0x61, data, DATA_LENGTH_1);//write 0x02 to 0x61
	//***clear fault
	data[0]=0x03;	//clear fault
	FlexBroadcast(0x60, data, DATA_LENGTH_1);//write 0x03 to 0x60 to clear CLR_POR and CLR_FAULT
	//***lock unchanged register
	data[0]=0x0B;	//lock
	FlexBroadcast(0x61, data, DATA_LENGTH_1);//write 0x0B to 0x61 to lock CLRLOCK, IOUTLOCK and PWMLOCK
	//***turn off all channels on device 9/1/12/4/10/2
	data[0]=0x00;
	data[0]=0x00;
	FlexWrite(DEV_ADDR_10, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 10
	FlexWrite(DEV_ADDR_2, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 2
	FlexWrite(DEV_ADDR_11, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 11
	FlexWrite(DEV_ADDR_3, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 3
	FlexWrite(DEV_ADDR_9, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 9
	FlexWrite(DEV_ADDR_1, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 1
	//delay(25000);//delay 500ms
}

void Tail_Flow_Off(unsigned int interval) 	//interval = 50 ---> 1ms
											//make sure call Tail_All_On() function before call this function
{
	char data[8];
	char Tail_10_2_data[8][2]={{0x00,0x00},{0x10,0x00},{0x30,0x00},{0x70,0x00},{0xF0,0x00},{0xF0,0x01},{0xF0,0x03},{0xF0,0x07}};
	char Tail_11_data[5][2]={{0x00,0x00},{0x03,0x00},{0x0F,0x00},{0x3F,0x00},{0xFF,0x00}};
	//char Tail_11_data[3][2]={{0x3F,0x00},{0xFF,0x00},{0xFF,0x03}};
	char Tail_3_data[5][2]={{0x00,0x00},{0x0C,0x00},{0x3C,0x00},{0xFC,0x00},{0xFC,0x03}};
	//char Tail_3_down_data[3][2]={{0xFC,0x00},{0xFC,0x03},{0xFC,0x0F}};
	char Tail_9_data[8][2]={{0x00,0x00},{0x80,0x00},{0xC0,0x00},{0xE0,0x00},{0xF0,0x00},{0xF8,0x00},{0xFC,0x00},{0xFE,0x00}};
	char Tail_1_data[8][2]={{0x00,0x00},{0x00,0x08},{0x00,0x0C},{0x00,0x0E},{0x00,0x0F},{0x80,0x0F},{0xC0,0x0F},{0xE0,0x0F}};
	unsigned int i;

	//***initialize
	data[0]=0x02;	//unlock
	FlexBroadcast(0x61, data, DATA_LENGTH_1);//write 0x02 to 0x61
	//***clear fault
	data[0]=0x03;	//clear fault
	FlexBroadcast(0x60, data, DATA_LENGTH_1);//write 0x03 to 0x60 to clear CLR_POR and CLR_FAULT
	//***lock unchanged register
	data[0]=0x0B;	//lock
	FlexBroadcast(0x61, data, DATA_LENGTH_1);//write 0x0B to 0x61 to lock CLRLOCK, IOUTLOCK and PWMLOCK

	//***start patterns
	//Tail -> Tail
	i=8;
	do //turn off device 9 and device 1 in turn
	{
		if(tailFlowFlag==0)
		{
			break;
		}
		i--;
		FlexWrite(DEV_ADDR_9, 0x50, Tail_9_data[i], DATA_LENGTH_2, TRUE);//turn off specified channels on device 9
		FlexWrite(DEV_ADDR_1, 0x50, Tail_1_data[i], DATA_LENGTH_2, TRUE);//turn off specified channels on device 1
		delay(interval);
	}while(i>0);
	i=5;
	do //turn off device 11 and device 3 in turn
	{
		if(tailFlowFlag==0)
		{
			break;
		}
		i--;
		FlexWrite(DEV_ADDR_11, 0x50, Tail_11_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 11
		FlexWrite(DEV_ADDR_3, 0x50, Tail_3_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 3
		delay(interval);
	}while(i>0);
	i=8;
	do //turn off device 10 and device 2 upper channels in turn
	{
		if(tailFlowFlag==0)
		{
			break;
		}
		i--;
		FlexWrite(DEV_ADDR_10, 0x50, Tail_10_2_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 10
		FlexWrite(DEV_ADDR_2, 0x50, Tail_10_2_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 2
		delay(interval);
	}while(i>0);
	//***keep OFF 100ms
	if(tailFlowFlag==1)
	{
		delay(20000);//delay 400ms
	}
}

void Greeting_and_Goodbye_update(unsigned int interval)//interval = 50 ---> 1ms
{
	char data[8], data_new[1], data_old[1];
	char Tail_10_2_flow_on_data[8][2]={{0x00,0x08},{0x00,0x0C},{0x00,0x0E},{0x00,0x0F},{0x80,0x0F},{0xC0,0x0F},{0xE0,0x0F},{0xF0,0x0F}};
	char Tail_10_2_single_on_data[8][2]={{0x10,0x00},{0x20,0x00},{0x40,0x00},{0x80,0x00},{0x00,0x01},{0x00,0x02},{0x00,0x04},{0x00,0x08}};
	char Tail_10_2_flow_off_data[8][2]={{0x00,0x00},{0x10,0x00},{0x30,0x00},{0x70,0x00},{0xF0,0x00},{0xF0,0x01},{0xF0,0x03},{0xF0,0x07}};

	char Tail_11_flow_on_data[5][2]={{0x00,0x03},{0xC0,0x03},{0xF0,0x03},{0xFC,0x03},{0xFF,0x03}};
	char Tail_11_single_on_data[5][2]={{0x03,0x00},{0x0C,0x00},{0x30,0x00},{0xC0,0x00},{0x00,0x03}};
	char Tail_11_flow_off_data[5][2]={{0x00,0x00},{0x03,0x00},{0x0F,0x00},{0x3F,0x00},{0xFF,0x00}};

	char Tail_3_flow_on_data[5][2]={{0x00,0x0C},{0x00,0x0F},{0xC0,0x0F},{0xF0,0x0F},{0xFC,0x0F}};
	char Tail_3_single_on_data[5][2]={{0x0C,0x00},{0x30,0x00},{0xC0,0x00},{0x00,0x03},{0x00,0x0C}};
	char Tail_3_flow_off_data[5][2]={{0x00,0x00},{0x0C,0x00},{0x3C,0x00},{0xFC,0x00},{0xFC,0x03}};

	char Tail_9_flow_on_data[7][2]={{0x03,0x00},{0x07,0x00},{0x0F,0x00},{0x1F,0x00},{0x3F,0x00},{0x7F,0x00},{0xFF,0x00}};
	char Tail_9_single_on_data[8][2]={{0x80,0x00},{0x40,0x00},{0x20,0x00},{0x10,0x00},{0x08,0x00},{0x04,0x00},{0x02,0x00},{0x01,0x00}};
	char Tail_9_flow_off_data[8][2]={{0x00,0x00},{0x80,0x00},{0xC0,0x00},{0xE0,0x00},{0xF0,0x00},{0xF8,0x00},{0xFC,0x00},{0xFE,0x00}};

	char Tail_1_flow_on_data[7][2]={{0x30,0x00},{0x70,0x00},{0xF0,0x00},{0xF0,0x01},{0xF0,0x03},{0xF0,0x07},{0xF0,0x0F}};
	char Tail_1_single_on_data[8][2]={{0x00,0x08},{0x00,0x04},{0x00,0x02},{0x00,0x01},{0x80,0x00},{0x40,0x00},{0x20,0x00},{0x10,0x00}};
	char Tail_1_flow_off_data[8][2]={{0x00,0x00},{0x00,0x08},{0x00,0x0C},{0x00,0x0E},{0x00,0x0F},{0x80,0x0F},{0xC0,0x0F},{0xE0,0x0F}};

	char Tail_10_2_Channel_num_data[8]={0x24,0x25,0x26,0x27,0x28,0x29,0x2A,0x2B};
	char Tail_11_channel_num_data[5]={0x20,0x22,0x24,0x26,0x28};//2 bytes per write
	char Tail_3_channel_num_data[5]={0x22,0x24,0x26,0x28,0x2A};//2 bytes per write
	char Tail_9_channel_num_data[8]={0x27,0x26,0x25,0x24,0x23,0x22,0x21,0x20};
	char Tail_1_channel_num_data[8]={0x2B,0x2A,0x29,0x28,0x27,0x26,0x25,0x24};

	unsigned int i=0,j;
	char PWM_Step_data[2]={0x80,0xFF}; //level 1, level 2, level 3, level 4

	//***initialize
	data[0]=0x02;	//unlock
	FlexBroadcast(0x61, data, DATA_LENGTH_1);//write 0x02 to 0x61
	//***clear fault
	data[0]=0x03;	//clear fault
	FlexBroadcast(0x60, data, DATA_LENGTH_1);//write 0x03 to 0x60 to clear CLR_POR and CLR_FAULT
	//***turn off all channels on device 10/2/11/3/9/1
	data[0]=0x00;
	data[1]=0x00;
	if(taiLGreetingFlag)
	{
		FlexWrite(DEV_ADDR_10, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 10
		FlexWrite(DEV_ADDR_2, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 2
		FlexWrite(DEV_ADDR_11, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 11
		FlexWrite(DEV_ADDR_3, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 3
		FlexWrite(DEV_ADDR_9, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 9
		FlexWrite(DEV_ADDR_1, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 1
		//***enable LUT and set PWM freq
		data[0]=0x10; //set CONF_EXPEN=1
		data[1]=0xA3;	//set PWM freq = 2000Hz
		FlexWrite(DEV_ADDR_10, 0x56, data, DATA_LENGTH_2, TRUE);//write 0x10 to 0x56 and write 0xA3 to 0x57, to enable LUT and set PWM freq on device 10
		FlexWrite(DEV_ADDR_2, 0x56, data, DATA_LENGTH_2, TRUE);//write 0x10 to 0x56 and write 0xA3 to 0x57, to enable LUT and set PWM freq on device 2
		FlexWrite(DEV_ADDR_11, 0x56, data, DATA_LENGTH_2, TRUE);//write 0x10 to 0x56 and write 0xA3 to 0x57, to enable LUT and set PWM freq on device 11
		FlexWrite(DEV_ADDR_3, 0x56, data, DATA_LENGTH_2, TRUE);//write 0x10 to 0x56 and write 0xA3 to 0x57, to enable LUT and set PWM freq on device 3
		FlexWrite(DEV_ADDR_9, 0x56, data, DATA_LENGTH_2, TRUE);//write 0x10 to 0x56 and write 0xA3 to 0x57, to enable LUT and set PWM freq on device 9
		FlexWrite(DEV_ADDR_1, 0x56, data, DATA_LENGTH_2, TRUE);//write 0x10 to 0x56 and write 0xA3 to 0x57, to enable LUT and set PWM freq on device 1
	}
	//******1st stage, brightness change from "off" to "level 1"****
	//***1.1 scan all channels with 0ff->level 1 -> off in turn
	//reset all channels' PWM value to level 1
	i=0;
	do
	{
		data[i]=PWM_Step_data[0];
		i++;
	}while(i<8);
	if(taiLGreetingFlag)
	{
		FlexWrite(DEV_ADDR_10, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 10
		FlexWrite(DEV_ADDR_10, 0x28, data, DATA_LENGTH_4, TRUE);
		FlexWrite(DEV_ADDR_2, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 2
		FlexWrite(DEV_ADDR_2, 0x28, data, DATA_LENGTH_4, TRUE);
		FlexWrite(DEV_ADDR_11, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 11
		FlexWrite(DEV_ADDR_11, 0x28, data, DATA_LENGTH_4, TRUE);
		FlexWrite(DEV_ADDR_3, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 3
		FlexWrite(DEV_ADDR_3, 0x28, data, DATA_LENGTH_4, TRUE);
		FlexWrite(DEV_ADDR_9, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 9
		FlexWrite(DEV_ADDR_9, 0x28, data, DATA_LENGTH_4, TRUE);
		FlexWrite(DEV_ADDR_1, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 1
		FlexWrite(DEV_ADDR_1, 0x28, data, DATA_LENGTH_4, TRUE);
	}
	//turn on all channels in turn one by one
	i=0;
	do //turn on device 10 and device 2 in turn
	{
		if(taiLGreetingFlag==0)
		{
			break;
		}
		FlexWrite(DEV_ADDR_10, 0x50, Tail_10_2_single_on_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 10
		FlexWrite(DEV_ADDR_2, 0x50, Tail_10_2_single_on_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 2
		delay(interval);
		i++;
	}while(i<8);
	//***turn off all channels on device 10/2
	if(taiLGreetingFlag)
	{
		data[0]=0x00;
		data[1]=0x00;
		FlexWrite(DEV_ADDR_10, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 10
		FlexWrite(DEV_ADDR_2, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 2
	}
	i=0;
	do //turn on device 11 and device 3 in turn
	{
		if(taiLGreetingFlag==0)
		{
			break;
		}
		FlexWrite(DEV_ADDR_11, 0x50, Tail_11_single_on_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 11
		FlexWrite(DEV_ADDR_3, 0x50, Tail_3_single_on_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 3
		delay(interval);
		i++;
	}while(i<5);
	//***turn off all channels on device 11/3
	if(taiLGreetingFlag)
	{
		data[0]=0x00;
		data[1]=0x00;
		FlexWrite(DEV_ADDR_11, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 11
		FlexWrite(DEV_ADDR_3, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 3
	}
	i=0;
	do //turn on device 9 and device 1 in turn
	{
		if(taiLGreetingFlag==0)
		{
			break;
		}
		FlexWrite(DEV_ADDR_9, 0x50, Tail_9_single_on_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 9
		FlexWrite(DEV_ADDR_1, 0x50, Tail_1_single_on_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 1
		delay(interval);
		i++;
	}while(i<8);
	//***turn off all channels on device 9/1
//	if(taiLGreetingFlag)
//	{
//		data[0]=0x00;
//		data[1]=0x00;
//		FlexWrite(DEV_ADDR_9, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 9
//		FlexWrite(DEV_ADDR_1, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 1
//	}
	//***1.2 turn on all channels to level 1 in turn
	i=0;
	do //turn on device 9 and device 1 in turn
	{
		if(taiLGreetingFlag==0)
		{
			break;
		}
		FlexWrite(DEV_ADDR_9, 0x50, Tail_9_flow_on_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 9
		FlexWrite(DEV_ADDR_1, 0x50, Tail_1_flow_on_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 1
		delay(interval);
		i++;
	}while(i<7);
	i=0;
	do //turn on device 11 and device 3 in turn
	{
		if(taiLGreetingFlag==0)
		{
			break;
		}
		FlexWrite(DEV_ADDR_11, 0x50, Tail_11_flow_on_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 11
		FlexWrite(DEV_ADDR_3, 0x50, Tail_3_flow_on_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 3
		delay(interval);
		i++;
	}while(i<5);
	i=0;
	do //turn on device 10 and device 2 in turn
	{
		if(taiLGreetingFlag==0)
		{
			break;
		}
		FlexWrite(DEV_ADDR_10, 0x50, Tail_10_2_flow_on_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 10
		FlexWrite(DEV_ADDR_2, 0x50, Tail_10_2_flow_on_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 2
		delay(interval);
		i++;
	}while(i<8);
	//keep ON 100ms
//	if(taiLGreetingFlag)
//	{
//		delay(10000);//delay 200ms
//	}
	//******2nd stage, brightness change from "level x" to "level x+1"****
	j=0;
	do
	{
		if(taiLGreetingFlag==0)
		{
			break;
		}
		//***2.1 scan all channels with level x->level x+1 -> level x in turn
		data_new[0]=PWM_Step_data[j+1];
		data_old[0]=PWM_Step_data[j];
		i=0;
		do //turn on device 10 and device 2 with new PWM value in turn
		{
			if(taiLGreetingFlag==0)
			{
				break;
			}
			FlexWrite(DEV_ADDR_10, Tail_10_2_Channel_num_data[i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			FlexWrite(DEV_ADDR_2, Tail_10_2_Channel_num_data[i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			delay(interval);
			FlexWrite(DEV_ADDR_10, Tail_10_2_Channel_num_data[i], data_old, DATA_LENGTH_1, TRUE);//assign back old value
			FlexWrite(DEV_ADDR_2, Tail_10_2_Channel_num_data[i], data_old, DATA_LENGTH_1, TRUE);//assign back old value
			i++;
		}while(i<8);
		i=0;
		do //turn on device 11 and device 3 in turn
		{
			if(taiLGreetingFlag==0)
			{
				break;
			}
			data[0]=data_new[0];
			data[1]=data_new[0];
			FlexWrite(DEV_ADDR_11, Tail_11_channel_num_data[i], data, DATA_LENGTH_2, TRUE);//assign new value
			FlexWrite(DEV_ADDR_3, Tail_3_channel_num_data[i], data, DATA_LENGTH_2, TRUE);//assign new value
			delay(interval);
			data[0]=data_old[0];
			data[1]=data_old[0];
			FlexWrite(DEV_ADDR_11, Tail_11_channel_num_data[i], data, DATA_LENGTH_2, TRUE);//assign back old value
			FlexWrite(DEV_ADDR_3, Tail_3_channel_num_data[i], data, DATA_LENGTH_2, TRUE);//assign back old value
			i++;
		}while(i<5);
		i=0;
		do //turn on device 9 and device 1 in turn
		{
			if(taiLGreetingFlag==0)
			{
				break;
			}
			FlexWrite(DEV_ADDR_9, Tail_9_channel_num_data[i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			FlexWrite(DEV_ADDR_1, Tail_1_channel_num_data[i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			delay(interval);
			if(i<7)
			{
				FlexWrite(DEV_ADDR_9, Tail_9_channel_num_data[i], data_old, DATA_LENGTH_1, TRUE);//assign back old value
				FlexWrite(DEV_ADDR_1, Tail_1_channel_num_data[i], data_old, DATA_LENGTH_1, TRUE);//assign back old value
			}
			i++;
		}while(i<8);

		//***2.2 scan all channels with level x->level x+1 in turn
		data_new[0]=PWM_Step_data[j+1];
		data_old[0]=PWM_Step_data[j];
		i=0;
		do //turn on device 9 and device 1 in turn
		{
			if(taiLGreetingFlag==0)
			{
				break;
			}
			FlexWrite(DEV_ADDR_9, Tail_9_channel_num_data[6-i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			FlexWrite(DEV_ADDR_1, Tail_1_channel_num_data[6-i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			delay(interval);
			i++;
		}while(i<7);
		i=0;
		do //turn on device 11 and device 3 in turn
		{
			if(taiLGreetingFlag==0)
			{
				break;
			}
			data[0]=data_new[0];
			data[1]=data_new[0];
			FlexWrite(DEV_ADDR_11, Tail_11_channel_num_data[4-i], data, DATA_LENGTH_2, TRUE);//assign new value
			FlexWrite(DEV_ADDR_3, Tail_3_channel_num_data[4-i], data, DATA_LENGTH_2, TRUE);//assign new value
			delay(interval);
			i++;
		}while(i<5);
		i=0;
		do //turn on device 10 and device 2 with new PWM value in turn
		{
			if(taiLGreetingFlag==0)
			{
				break;
			}
			FlexWrite(DEV_ADDR_10, Tail_10_2_Channel_num_data[7-i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			FlexWrite(DEV_ADDR_2, Tail_10_2_Channel_num_data[7-i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			delay(interval);
			i++;
		}while(i<8);
		j++;
	}while(j<1);
	//keep ON 200ms
//	if(taiLGreetingFlag)
//	{
//		delay(10000);//delay 200ms
//	}
	//******3rd stage, brightness change from "level X+1" to "level x"****
	do
	{
		if(taiLGreetingFlag==0)
		{
			break;
		}
		data_new[0]=PWM_Step_data[j-1];
		i=0;
		do //turn on device 10 and device 2 with new PWM value in turn
		{
			if(taiLGreetingFlag==0)
			{
				break;
			}
			FlexWrite(DEV_ADDR_10, Tail_10_2_Channel_num_data[i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			FlexWrite(DEV_ADDR_2, Tail_10_2_Channel_num_data[i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			delay(interval);
			i++;
		}while(i<8);
		i=0;
		do //turn on device 11 and device 3 with new PWM value in turn
		{
			if(taiLGreetingFlag==0)
			{
				break;
			}
			data[0]=data_new[0];
			data[1]=data_new[0];
			FlexWrite(DEV_ADDR_11, Tail_11_channel_num_data[i], data, DATA_LENGTH_2, TRUE);//assign new value
			FlexWrite(DEV_ADDR_3, Tail_3_channel_num_data[i], data, DATA_LENGTH_2, TRUE);//assign new value
			delay(interval);
			i++;
		}while(i<5);
		i=0;
		do //turn on device 9 and device 1 with new PWM value in turn
		{
			if(taiLGreetingFlag==0)
			{
				break;
			}
			FlexWrite(DEV_ADDR_9, Tail_9_channel_num_data[i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			FlexWrite(DEV_ADDR_1, Tail_1_channel_num_data[i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			delay(interval);
			i++;
		}while(i<8);
		j--;
	}while(j>0);

	//***4th turn off all channels from level 1 in turn
	i=0;
	do //turn off device 9 and device 1 in turn
	{
		if(taiLGreetingFlag==0)
		{
			break;
		}
		FlexWrite(DEV_ADDR_9, 0x50, Tail_9_flow_off_data[7-i], DATA_LENGTH_2, TRUE);//turn off specified channels on device 9
		FlexWrite(DEV_ADDR_1, 0x50, Tail_1_flow_off_data[7-i], DATA_LENGTH_2, TRUE);//turn off specified channels on device 1
		delay(interval);
		i++;
	}while(i<8);
	i=0;
	do //turn off device 11 and device 3 in turn
	{
		if(taiLGreetingFlag==0)
		{
			break;
		}
		FlexWrite(DEV_ADDR_11, 0x50, Tail_11_flow_off_data[4-i], DATA_LENGTH_2, TRUE);//turn off specified channels on device 11
		FlexWrite(DEV_ADDR_3, 0x50, Tail_3_flow_off_data[4-i], DATA_LENGTH_2, TRUE);//turn off specified channels on device 3
		delay(interval);
		i++;
	}while(i<5);
	i=0;
	do //turn off device 10 and device 2 in turn
	{
		if(taiLGreetingFlag==0)
		{
			break;
		}
		FlexWrite(DEV_ADDR_10, 0x50, Tail_10_2_flow_off_data[7-i], DATA_LENGTH_2, TRUE);//turn off specified channels on device 10
		FlexWrite(DEV_ADDR_2, 0x50, Tail_10_2_flow_off_data[7-i], DATA_LENGTH_2, TRUE);//turn off specified channels on device 2
		delay(interval);
		i++;
	}while(i<8);
	//*******5th Stage, reset all channels' PWM value to 0xFF
	i=0;
	do
	{
		data[i]=0xFF;
		i++;
	}while(i<8);
	FlexWrite(DEV_ADDR_10, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 10
	FlexWrite(DEV_ADDR_10, 0x28, data, DATA_LENGTH_4, TRUE);
	FlexWrite(DEV_ADDR_2, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 2
	FlexWrite(DEV_ADDR_2, 0x28, data, DATA_LENGTH_4, TRUE);
	FlexWrite(DEV_ADDR_11, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 11
	FlexWrite(DEV_ADDR_11, 0x28, data, DATA_LENGTH_4, TRUE);
	FlexWrite(DEV_ADDR_3, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 3
	FlexWrite(DEV_ADDR_3, 0x28, data, DATA_LENGTH_4, TRUE);
	FlexWrite(DEV_ADDR_9, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 9
	FlexWrite(DEV_ADDR_9, 0x28, data, DATA_LENGTH_4, TRUE);
	FlexWrite(DEV_ADDR_1, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 1
	FlexWrite(DEV_ADDR_1, 0x28, data, DATA_LENGTH_4, TRUE);
}

void Goodbye_update(unsigned int interval)//interval = 50 ---> 1ms
{
	char data[8], data_new[1], data_old[1];
	//char Tail_10_2_flow_on_data[8][2]={{0x10,0x00},{0x30,0x00},{0x70,0x00},{0xF0,0x00},{0xF0,0x01},{0xF0,0x03},{0xF0,0x07},{0xF0,0x0F}};
	//char Tail_10_2_single_on_data[8][2]={{0x10,0x00},{0x20,0x00},{0x40,0x00},{0x80,0x00},{0x00,0x01},{0x00,0x02},{0x00,0x04},{0x00,0x08}};
	char Tail_10_2_flow_off_data[8][2]={{0x00,0x00},{0x10,0x00},{0x30,0x00},{0x70,0x00},{0xF0,0x00},{0xF0,0x01},{0xF0,0x03},{0xF0,0x07}};

	//char Tail_11_flow_on_data[5][2]={{0x03,0x00},{0x0F,0x00},{0x3F,0x00},{0xFF,0x00},{0xFF,0x03}};
	//char Tail_11_single_on_data[5][2]={{0x03,0x00},{0x0C,0x00},{0x30,0x00},{0xC0,0x00},{0x00,0x03}};
	char Tail_11_flow_off_data[5][2]={{0x00,0x00},{0x03,0x00},{0x0F,0x00},{0x3F,0x00},{0xFF,0x00}};

	//char Tail_3_flow_on_data[5][2]={{0x0C,0x00},{0x3C,0x00},{0xFC,0x00},{0xFC,0x03},{0xFC,0x0F}};
	//char Tail_3_single_on_data[5][2]={{0x0C,0x00},{0x30,0x00},{0xC0,0x00},{0x00,0x03},{0x00,0x0C}};
	char Tail_3_flow_off_data[5][2]={{0x00,0x00},{0x0C,0x00},{0x3C,0x00},{0xFC,0x00},{0xFC,0x03}};

	//char Tail_9_flow_on_data[8][2]={{0x80,0x00},{0xC0,0x00},{0xE0,0x00},{0xF0,0x00},{0xF8,0x00},{0xFC,0x00},{0xFE,0x00},{0xFF,0x00}};
	//char Tail_9_single_on_data[8][2]={{0x80,0x00},{0x40,0x00},{0x20,0x00},{0x10,0x00},{0x00,0x08},{0x00,0x04},{0x00,0x02},{0x00,0x01}};
	char Tail_9_flow_off_data[8][2]={{0x00,0x00},{0x80,0x00},{0xC0,0x00},{0xE0,0x00},{0xF0,0x00},{0xF8,0x00},{0xFC,0x00},{0xFE,0x00}};

	//char Tail_1_flow_on_data[8][2]={{0x00,0x08},{0x00,0x0C},{0x00,0x0E},{0x00,0x0F},{0x80,0x0F},{0xC0,0x0F},{0xE0,0x0F},{0xF0,0x0F}};
	//char Tail_1_single_on_data[8][2]={{0x00,0x08},{0x00,0x04},{0x00,0x02},{0x00,0x01},{0x80,0x00},{0x40,0x00},{0x20,0x00},{0x10,0x00}};
	char Tail_1_flow_off_data[8][2]={{0x00,0x00},{0x00,0x08},{0x00,0x0C},{0x00,0x0E},{0x00,0x0F},{0x80,0x0F},{0xC0,0x0F},{0xE0,0x0F}};

	char Tail_10_2_Channel_num_data[8]={0x24,0x25,0x26,0x27,0x28,0x29,0x2A,0x2B};
	char Tail_11_channel_num_data[5]={0x20,0x22,0x24,0x26,0x28};//2 bytes per write
	char Tail_3_channel_num_data[5]={0x22,0x24,0x26,0x28,0x2A};//2 bytes per write
	char Tail_9_channel_num_data[8]={0x27,0x26,0x25,0x24,0x23,0x22,0x21,0x20};
	char Tail_1_channel_num_data[8]={0x2B,0x2A,0x29,0x28,0x27,0x26,0x25,0x24};

	unsigned int i=0,j;
	char PWM_Step_data[2]={0x80,0xFF}; //level 1, level 2, level 3, level 4

	//***initialize
	data[0]=0x02;	//unlock
	FlexBroadcast(0x61, data, DATA_LENGTH_1);//write 0x02 to 0x61
	//***clear fault
	data[0]=0x03;	//clear fault
	FlexBroadcast(0x60, data, DATA_LENGTH_1);//write 0x03 to 0x60 to clear CLR_POR and CLR_FAULT

	//***enable LUT and set PWM freq
	if(tailGoodbyeFlag)
	{
		data[0]=0x10; //set CONF_EXPEN=1
		data[1]=0xA3;	//set PWM freq = 2000Hz
		FlexWrite(DEV_ADDR_10, 0x56, data, DATA_LENGTH_2, TRUE);//write 0x10 to 0x56 and write 0xA3 to 0x57, to enable LUT and set PWM freq on device 10
		FlexWrite(DEV_ADDR_2, 0x56, data, DATA_LENGTH_2, TRUE);//write 0x10 to 0x56 and write 0xA3 to 0x57, to enable LUT and set PWM freq on device 2
		FlexWrite(DEV_ADDR_11, 0x56, data, DATA_LENGTH_2, TRUE);//write 0x10 to 0x56 and write 0xA3 to 0x57, to enable LUT and set PWM freq on device 11
		FlexWrite(DEV_ADDR_3, 0x56, data, DATA_LENGTH_2, TRUE);//write 0x10 to 0x56 and write 0xA3 to 0x57, to enable LUT and set PWM freq on device 3
		FlexWrite(DEV_ADDR_9, 0x56, data, DATA_LENGTH_2, TRUE);//write 0x10 to 0x56 and write 0xA3 to 0x57, to enable LUT and set PWM freq on device 9
		FlexWrite(DEV_ADDR_1, 0x56, data, DATA_LENGTH_2, TRUE);//write 0x10 to 0x56 and write 0xA3 to 0x57, to enable LUT and set PWM freq on device 1
	}
	//******3rd stage, brightness change from "level X+1" to "level x"****
	j=1;
	do
	{
		if(tailGoodbyeFlag==0)
		{
			break;
		}
		data_new[0]=PWM_Step_data[j-1];
		i=0;
		do //turn on device 10 and device 2 with new PWM value in turn
		{
			if(tailGoodbyeFlag==0)
			{
				break;
			}
			FlexWrite(DEV_ADDR_10, Tail_10_2_Channel_num_data[i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			FlexWrite(DEV_ADDR_2, Tail_10_2_Channel_num_data[i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			delay(interval);
			i++;
		}while(i<8);
		i=0;
		do //turn on device 11 and device 3 with new PWM value in turn
		{
			if(tailGoodbyeFlag==0)
			{
				break;
			}
			data[0]=data_new[0];
			data[1]=data_new[0];
			FlexWrite(DEV_ADDR_11, Tail_11_channel_num_data[i], data, DATA_LENGTH_2, TRUE);//assign new value
			FlexWrite(DEV_ADDR_3, Tail_3_channel_num_data[i], data, DATA_LENGTH_2, TRUE);//assign new value
			delay(interval);
			i++;
		}while(i<5);
		i=0;
		do //turn on device 9 and device 1 with new PWM value in turn
		{
			if(tailGoodbyeFlag==0)
			{
				break;
			}
			FlexWrite(DEV_ADDR_9, Tail_9_channel_num_data[i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			FlexWrite(DEV_ADDR_1, Tail_1_channel_num_data[i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			delay(interval);
			i++;
		}while(i<8);
		j--;
	}while(j>0);

	//***4th turn off all channels from level 1 in turn
	i=0;
	do //turn off device 9 and device 1 in turn
	{
		if(tailGoodbyeFlag==0)
		{
			break;
		}
		FlexWrite(DEV_ADDR_9, 0x50, Tail_9_flow_off_data[7-i], DATA_LENGTH_2, TRUE);//turn off specified channels on device 9
		FlexWrite(DEV_ADDR_1, 0x50, Tail_1_flow_off_data[7-i], DATA_LENGTH_2, TRUE);//turn off specified channels on device 1
		delay(interval);
		i++;
	}while(i<8);
	i=0;
	do //turn off device 11 and device 3 in turn
	{
		if(tailGoodbyeFlag==0)
		{
			break;
		}
		FlexWrite(DEV_ADDR_11, 0x50, Tail_11_flow_off_data[4-i], DATA_LENGTH_2, TRUE);//turn off specified channels on device 11
		FlexWrite(DEV_ADDR_3, 0x50, Tail_3_flow_off_data[4-i], DATA_LENGTH_2, TRUE);//turn off specified channels on device 3
		delay(interval);
		i++;
	}while(i<5);
	i=0;
	do //turn off device 10 and device 2 in turn
	{
		if(tailGoodbyeFlag==0)
		{
			break;
		}
		FlexWrite(DEV_ADDR_10, 0x50, Tail_10_2_flow_off_data[7-i], DATA_LENGTH_2, TRUE);//turn off specified channels on device 10
		FlexWrite(DEV_ADDR_2, 0x50, Tail_10_2_flow_off_data[7-i], DATA_LENGTH_2, TRUE);//turn off specified channels on device 2
		delay(interval);
		i++;
	}while(i<8);
	//***turn off all channels on device 9/1/12/4/10/2
	data[0]=0x00;
	data[0]=0x00;
	FlexWrite(DEV_ADDR_10, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 10
	FlexWrite(DEV_ADDR_2, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 2
	FlexWrite(DEV_ADDR_11, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 11
	FlexWrite(DEV_ADDR_3, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 3
	FlexWrite(DEV_ADDR_9, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 9
	FlexWrite(DEV_ADDR_1, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 1
	i=0;
	//*******5th Stage, reset all channels' PWM value to 0xFF
	do
	{
		data[i]=0xFF;
		i++;
	}while(i<8);
	FlexWrite(DEV_ADDR_10, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 10
	FlexWrite(DEV_ADDR_10, 0x28, data, DATA_LENGTH_4, TRUE);
	FlexWrite(DEV_ADDR_2, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 2
	FlexWrite(DEV_ADDR_2, 0x28, data, DATA_LENGTH_4, TRUE);
	FlexWrite(DEV_ADDR_11, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 11
	FlexWrite(DEV_ADDR_11, 0x28, data, DATA_LENGTH_4, TRUE);
	FlexWrite(DEV_ADDR_3, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 3
	FlexWrite(DEV_ADDR_3, 0x28, data, DATA_LENGTH_4, TRUE);
	FlexWrite(DEV_ADDR_9, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 9
	FlexWrite(DEV_ADDR_9, 0x28, data, DATA_LENGTH_4, TRUE);
	FlexWrite(DEV_ADDR_1, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 1
	FlexWrite(DEV_ADDR_1, 0x28, data, DATA_LENGTH_4, TRUE);
}

void Greeting_and_Goodbye(unsigned int interval)//interval = 50 ---> 1ms
{
	char data[8], data_new[1], data_old[1];
	char Tail_10_2_flow_on_data[8][2]={{0x10,0x00},{0x30,0x00},{0x70,0x00},{0xF0,0x00},{0xF0,0x01},{0xF0,0x03},{0xF0,0x07},{0xF0,0x0F}};
	char Tail_10_2_single_on_data[8][2]={{0x10,0x00},{0x20,0x00},{0x40,0x00},{0x80,0x00},{0x00,0x01},{0x00,0x02},{0x00,0x04},{0x00,0x08}};
	char Tail_10_2_flow_off_data[8][2]={{0x00,0x00},{0x10,0x00},{0x30,0x00},{0x70,0x00},{0xF0,0x00},{0xF0,0x01},{0xF0,0x03},{0xF0,0x07}};

	char Tail_11_flow_on_data[5][2]={{0x03,0x00},{0x0F,0x00},{0x3F,0x00},{0xFF,0x00},{0xFF,0x03}};
	char Tail_11_single_on_data[5][2]={{0x03,0x00},{0x0C,0x00},{0x30,0x00},{0xC0,0x00},{0x00,0x03}};
	char Tail_11_flow_off_data[5][2]={{0x00,0x00},{0x03,0x00},{0x0F,0x00},{0x3F,0x00},{0xFF,0x00}};

	char Tail_3_flow_on_data[5][2]={{0x0C,0x00},{0x3C,0x00},{0xFC,0x00},{0xFC,0x03},{0xFC,0x0F}};
	char Tail_3_single_on_data[5][2]={{0x0C,0x00},{0x30,0x00},{0xC0,0x00},{0x00,0x03},{0x00,0x0C}};
	char Tail_3_flow_off_data[5][2]={{0x00,0x00},{0x0C,0x00},{0x3C,0x00},{0xFC,0x00},{0xFC,0x03}};

	char Tail_9_flow_on_data[8][2]={{0x80,0x00},{0xC0,0x00},{0xE0,0x00},{0xF0,0x00},{0xF8,0x00},{0xFC,0x00},{0xFE,0x00},{0xFF,0x00}};
	char Tail_9_single_on_data[8][2]={{0x80,0x00},{0x40,0x00},{0x20,0x00},{0x10,0x00},{0x08,0x00},{0x04,0x00},{0x02,0x00},{0x01,0x00}};
	char Tail_9_flow_off_data[8][2]={{0x00,0x00},{0x80,0x00},{0xC0,0x00},{0xE0,0x00},{0xF0,0x00},{0xF8,0x00},{0xFC,0x00},{0xFE,0x00}};

	char Tail_1_flow_on_data[8][2]={{0x00,0x08},{0x00,0x0C},{0x00,0x0E},{0x00,0x0F},{0x80,0x0F},{0xC0,0x0F},{0xE0,0x0F},{0xF0,0x0F}};
	char Tail_1_single_on_data[8][2]={{0x00,0x08},{0x00,0x04},{0x00,0x02},{0x00,0x01},{0x80,0x00},{0x40,0x00},{0x20,0x00},{0x10,0x00}};
	char Tail_1_flow_off_data[8][2]={{0x00,0x00},{0x00,0x08},{0x00,0x0C},{0x00,0x0E},{0x00,0x0F},{0x80,0x0F},{0xC0,0x0F},{0xE0,0x0F}};

	char Tail_10_2_Channel_num_data[8]={0x24,0x25,0x26,0x27,0x28,0x29,0x2A,0x2B};
	char Tail_11_channel_num_data[5]={0x20,0x22,0x24,0x26,0x28};//2 bytes per write
	char Tail_3_channel_num_data[5]={0x22,0x24,0x26,0x28,0x2A};//2 bytes per write
	char Tail_9_channel_num_data[8]={0x27,0x26,0x25,0x24,0x23,0x22,0x21,0x20};
	char Tail_1_channel_num_data[8]={0x2B,0x2A,0x29,0x28,0x27,0x26,0x25,0x24};

	unsigned int i=0,j;
	char PWM_Step_data[2]={0x80,0xFF}; //level 1, level 2, level 3, level 4

	//***initialize
	data[0]=0x02;	//unlock
	FlexBroadcast(0x61, data, DATA_LENGTH_1);//write 0x02 to 0x61
	//***clear fault
	data[0]=0x03;	//clear fault
	FlexBroadcast(0x60, data, DATA_LENGTH_1);//write 0x03 to 0x60 to clear CLR_POR and CLR_FAULT
	//***turn off all channels on device 10/2/11/3/9/1
	data[0]=0x00;
	data[1]=0x00;
	if(taiLGreetingFlag)
	{
		FlexWrite(DEV_ADDR_10, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 10
		FlexWrite(DEV_ADDR_2, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 2
		FlexWrite(DEV_ADDR_11, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 11
		FlexWrite(DEV_ADDR_3, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 3
		FlexWrite(DEV_ADDR_9, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 9
		FlexWrite(DEV_ADDR_1, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 1
		//***enable LUT and set PWM freq
		data[0]=0x10; //set CONF_EXPEN=1
		data[1]=0xA3;	//set PWM freq = 2000Hz
		FlexWrite(DEV_ADDR_10, 0x56, data, DATA_LENGTH_2, TRUE);//write 0x10 to 0x56 and write 0xA3 to 0x57, to enable LUT and set PWM freq on device 10
		FlexWrite(DEV_ADDR_2, 0x56, data, DATA_LENGTH_2, TRUE);//write 0x10 to 0x56 and write 0xA3 to 0x57, to enable LUT and set PWM freq on device 2
		FlexWrite(DEV_ADDR_11, 0x56, data, DATA_LENGTH_2, TRUE);//write 0x10 to 0x56 and write 0xA3 to 0x57, to enable LUT and set PWM freq on device 11
		FlexWrite(DEV_ADDR_3, 0x56, data, DATA_LENGTH_2, TRUE);//write 0x10 to 0x56 and write 0xA3 to 0x57, to enable LUT and set PWM freq on device 3
		FlexWrite(DEV_ADDR_9, 0x56, data, DATA_LENGTH_2, TRUE);//write 0x10 to 0x56 and write 0xA3 to 0x57, to enable LUT and set PWM freq on device 9
		FlexWrite(DEV_ADDR_1, 0x56, data, DATA_LENGTH_2, TRUE);//write 0x10 to 0x56 and write 0xA3 to 0x57, to enable LUT and set PWM freq on device 1
	}
	//******1st stage, brightness change from "off" to "level 1"****
	//***1.1 scan all channels with 0ff->level 1 -> off in turn
	//reset all channels' PWM value to level 1
	i=0;
	do
	{
		data[i]=PWM_Step_data[0];
		i++;
	}while(i<8);
	if(taiLGreetingFlag)
	{
		FlexWrite(DEV_ADDR_10, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 10
		FlexWrite(DEV_ADDR_10, 0x28, data, DATA_LENGTH_4, TRUE);
		FlexWrite(DEV_ADDR_2, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 2
		FlexWrite(DEV_ADDR_2, 0x28, data, DATA_LENGTH_4, TRUE);
		FlexWrite(DEV_ADDR_11, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 11
		FlexWrite(DEV_ADDR_11, 0x28, data, DATA_LENGTH_4, TRUE);
		FlexWrite(DEV_ADDR_3, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 3
		FlexWrite(DEV_ADDR_3, 0x28, data, DATA_LENGTH_4, TRUE);
		FlexWrite(DEV_ADDR_9, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 9
		FlexWrite(DEV_ADDR_9, 0x28, data, DATA_LENGTH_4, TRUE);
		FlexWrite(DEV_ADDR_1, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 1
		FlexWrite(DEV_ADDR_1, 0x28, data, DATA_LENGTH_4, TRUE);
	}
	//turn on all channels in turn one by one
	i=0;
	do //turn on device 10 and device 2 in turn
	{
		if(taiLGreetingFlag==0)
		{
			break;
		}
		FlexWrite(DEV_ADDR_10, 0x50, Tail_10_2_single_on_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 10
		FlexWrite(DEV_ADDR_2, 0x50, Tail_10_2_single_on_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 2
		delay(interval);
		i++;
	}while(i<8);
	//***turn off all channels on device 10/2
	if(taiLGreetingFlag)
	{
		data[0]=0x00;
		data[1]=0x00;
		FlexWrite(DEV_ADDR_10, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 10
		FlexWrite(DEV_ADDR_2, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 2
	}
	i=0;
	do //turn on device 11 and device 3 in turn
	{
		if(taiLGreetingFlag==0)
		{
			break;
		}
		FlexWrite(DEV_ADDR_11, 0x50, Tail_11_single_on_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 11
		FlexWrite(DEV_ADDR_3, 0x50, Tail_3_single_on_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 3
		delay(interval);
		i++;
	}while(i<5);
	//***turn off all channels on device 11/3
	if(taiLGreetingFlag)
	{
		data[0]=0x00;
		data[1]=0x00;
		FlexWrite(DEV_ADDR_11, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 11
		FlexWrite(DEV_ADDR_3, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 3
	}
	i=0;
	do //turn on device 9 and device 1 in turn
	{
		if(taiLGreetingFlag==0)
		{
			break;
		}
		FlexWrite(DEV_ADDR_9, 0x50, Tail_9_single_on_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 9
		FlexWrite(DEV_ADDR_1, 0x50, Tail_1_single_on_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 1
		delay(interval);
		i++;
	}while(i<8);
	//***turn off all channels on device 9/1
	if(taiLGreetingFlag)
	{
		data[0]=0x00;
		data[1]=0x00;
		FlexWrite(DEV_ADDR_9, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 9
		FlexWrite(DEV_ADDR_1, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 1
	}
	//***1.2 turn on all channels to level 1 in turn
	i=0;
	do //turn on device 10 and device 2 in turn
	{
		if(taiLGreetingFlag==0)
		{
			break;
		}
		FlexWrite(DEV_ADDR_10, 0x50, Tail_10_2_flow_on_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 10
		FlexWrite(DEV_ADDR_2, 0x50, Tail_10_2_flow_on_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 2
		delay(interval);
		i++;
	}while(i<8);
	i=0;
	do //turn on device 11 and device 3 in turn
	{
		if(taiLGreetingFlag==0)
		{
			break;
		}
		FlexWrite(DEV_ADDR_11, 0x50, Tail_11_flow_on_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 11
		FlexWrite(DEV_ADDR_3, 0x50, Tail_3_flow_on_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 3
		delay(interval);
		i++;
	}while(i<5);
	i=0;
	do //turn on device 9 and device 1 in turn
	{
		if(taiLGreetingFlag==0)
		{
			break;
		}
		FlexWrite(DEV_ADDR_9, 0x50, Tail_9_flow_on_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 9
		FlexWrite(DEV_ADDR_1, 0x50, Tail_1_flow_on_data[i], DATA_LENGTH_2, TRUE);//turn on specified channels on device 1
		delay(interval);
		i++;
	}while(i<8);
	//keep ON 100ms
	if(taiLGreetingFlag)
	{
		delay(10000);//delay 200ms
	}
	//******2nd stage, brightness change from "level x" to "level x+1"****
	j=0;
	do
	{
		if(taiLGreetingFlag==0)
		{
			break;
		}
		//***2.1 scan all channels with level x->level x+1 -> level x in turn
		data_new[0]=PWM_Step_data[j+1];
		data_old[0]=PWM_Step_data[j];
		i=0;
		do //turn on device 10 and device 2 with new PWM value in turn
		{
			if(taiLGreetingFlag==0)
			{
				break;
			}
			FlexWrite(DEV_ADDR_10, Tail_10_2_Channel_num_data[i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			FlexWrite(DEV_ADDR_2, Tail_10_2_Channel_num_data[i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			delay(interval);
			FlexWrite(DEV_ADDR_10, Tail_10_2_Channel_num_data[i], data_old, DATA_LENGTH_1, TRUE);//assign back old value
			FlexWrite(DEV_ADDR_2, Tail_10_2_Channel_num_data[i], data_old, DATA_LENGTH_1, TRUE);//assign back old value
			i++;
		}while(i<8);
		i=0;
		do //turn on device 11 and device 3 in turn
		{
			if(taiLGreetingFlag==0)
			{
				break;
			}
			data[0]=data_new[0];
			data[1]=data_new[0];
			FlexWrite(DEV_ADDR_11, Tail_11_channel_num_data[i], data, DATA_LENGTH_2, TRUE);//assign new value
			FlexWrite(DEV_ADDR_3, Tail_3_channel_num_data[i], data, DATA_LENGTH_2, TRUE);//assign new value
			delay(interval);
			data[0]=data_old[0];
			data[1]=data_old[0];
			FlexWrite(DEV_ADDR_11, Tail_11_channel_num_data[i], data, DATA_LENGTH_2, TRUE);//assign back old value
			FlexWrite(DEV_ADDR_3, Tail_3_channel_num_data[i], data, DATA_LENGTH_2, TRUE);//assign back old value
			i++;
		}while(i<5);
		i=0;
		do //turn on device 9 and device 1 in turn
		{
			if(taiLGreetingFlag==0)
			{
				break;
			}
			FlexWrite(DEV_ADDR_9, Tail_9_channel_num_data[i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			FlexWrite(DEV_ADDR_1, Tail_1_channel_num_data[i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			delay(interval);
			FlexWrite(DEV_ADDR_9, Tail_9_channel_num_data[i], data_old, DATA_LENGTH_1, TRUE);//assign back old value
			FlexWrite(DEV_ADDR_1, Tail_1_channel_num_data[i], data_old, DATA_LENGTH_1, TRUE);//assign back old value
			i++;
		}while(i<8);

		//***2.2 scan all channels with level x->level x+1 in turn
		data_new[0]=PWM_Step_data[j+1];
		data_old[0]=PWM_Step_data[j];
		i=0;
		do //turn on device 10 and device 2 with new PWM value in turn
		{
			if(taiLGreetingFlag==0)
			{
				break;
			}
			FlexWrite(DEV_ADDR_10, Tail_10_2_Channel_num_data[i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			FlexWrite(DEV_ADDR_2, Tail_10_2_Channel_num_data[i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			delay(interval);
			i++;
		}while(i<8);
		i=0;
		do //turn on device 11 and device 3 in turn
		{
			if(taiLGreetingFlag==0)
			{
				break;
			}
			data[0]=data_new[0];
			data[1]=data_new[0];
			FlexWrite(DEV_ADDR_11, Tail_11_channel_num_data[i], data, DATA_LENGTH_2, TRUE);//assign new value
			FlexWrite(DEV_ADDR_3, Tail_3_channel_num_data[i], data, DATA_LENGTH_2, TRUE);//assign new value
			delay(interval);
			i++;
		}while(i<5);
		i=0;
		do //turn on device 9 and device 1 in turn
		{
			if(taiLGreetingFlag==0)
			{
				break;
			}
			FlexWrite(DEV_ADDR_9, Tail_9_channel_num_data[i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			FlexWrite(DEV_ADDR_1, Tail_1_channel_num_data[i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			delay(interval);
			i++;
		}while(i<8);
		j++;
	}while(j<1);
	//keep ON 200ms
	if(taiLGreetingFlag)
	{
		delay(10000);//delay 200ms
	}
	//******3rd stage, brightness change from "level X+1" to "level x"****
	do
	{
		if(taiLGreetingFlag==0)
		{
			break;
		}
		data_new[0]=PWM_Step_data[j-1];

		i=0;
		do //turn on device 9 and device 1 with new PWM value in turn
		{
			if(taiLGreetingFlag==0)
			{
				break;
			}
			FlexWrite(DEV_ADDR_9, Tail_9_channel_num_data[7-i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			FlexWrite(DEV_ADDR_1, Tail_1_channel_num_data[7-i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			delay(interval);
			i++;
		}while(i<8);

		i=0;
		do //turn on device 11 and device 3 with new PWM value in turn
		{
			if(taiLGreetingFlag==0)
			{
				break;
			}
			data[0]=data_new[0];
			data[1]=data_new[0];
			FlexWrite(DEV_ADDR_11, Tail_11_channel_num_data[4-i], data, DATA_LENGTH_2, TRUE);//assign new value
			FlexWrite(DEV_ADDR_3, Tail_3_channel_num_data[4-i], data, DATA_LENGTH_2, TRUE);//assign new value
			delay(interval);
			i++;
		}while(i<5);
		i=0;
		do //turn on device 10 and device 2 with new PWM value in turn
		{
			if(taiLGreetingFlag==0)
			{
				break;
			}
			FlexWrite(DEV_ADDR_10, Tail_10_2_Channel_num_data[7-i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			FlexWrite(DEV_ADDR_2, Tail_10_2_Channel_num_data[7-i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			delay(interval);
			i++;
		}while(i<8);
		j--;
	}while(j>0);

	//***4th turn off all channels from level 1 in turn
	i=0;
	do //turn off device 9 and device 1 in turn
	{
		if(taiLGreetingFlag==0)
		{
			break;
		}
		FlexWrite(DEV_ADDR_9, 0x50, Tail_9_flow_off_data[7-i], DATA_LENGTH_2, TRUE);//turn off specified channels on device 9
		FlexWrite(DEV_ADDR_1, 0x50, Tail_1_flow_off_data[7-i], DATA_LENGTH_2, TRUE);//turn off specified channels on device 1
		delay(interval);
		i++;
	}while(i<8);
	i=0;
	do //turn off device 11 and device 3 in turn
	{
		if(taiLGreetingFlag==0)
		{
			break;
		}
		FlexWrite(DEV_ADDR_11, 0x50, Tail_11_flow_off_data[4-i], DATA_LENGTH_2, TRUE);//turn off specified channels on device 11
		FlexWrite(DEV_ADDR_3, 0x50, Tail_3_flow_off_data[4-i], DATA_LENGTH_2, TRUE);//turn off specified channels on device 3
		delay(interval);
		i++;
	}while(i<5);
	i=0;
	do //turn off device 10 and device 2 in turn
	{
		if(taiLGreetingFlag==0)
		{
			break;
		}
		FlexWrite(DEV_ADDR_10, 0x50, Tail_10_2_flow_off_data[7-i], DATA_LENGTH_2, TRUE);//turn off specified channels on device 10
		FlexWrite(DEV_ADDR_2, 0x50, Tail_10_2_flow_off_data[7-i], DATA_LENGTH_2, TRUE);//turn off specified channels on device 2
		delay(interval);
		i++;
	}while(i<8);
	i=0;
	//*******5th Stage, reset all channels' PWM value to 0xFF
	i=0;
	do
	{
		data[i]=0xFF;
		i++;
	}while(i<8);
	FlexWrite(DEV_ADDR_10, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 10
	FlexWrite(DEV_ADDR_10, 0x28, data, DATA_LENGTH_4, TRUE);
	FlexWrite(DEV_ADDR_2, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 2
	FlexWrite(DEV_ADDR_2, 0x28, data, DATA_LENGTH_4, TRUE);
	FlexWrite(DEV_ADDR_11, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 11
	FlexWrite(DEV_ADDR_11, 0x28, data, DATA_LENGTH_4, TRUE);
	FlexWrite(DEV_ADDR_3, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 3
	FlexWrite(DEV_ADDR_3, 0x28, data, DATA_LENGTH_4, TRUE);
	FlexWrite(DEV_ADDR_9, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 9
	FlexWrite(DEV_ADDR_9, 0x28, data, DATA_LENGTH_4, TRUE);
	FlexWrite(DEV_ADDR_1, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 1
	FlexWrite(DEV_ADDR_1, 0x28, data, DATA_LENGTH_4, TRUE);
}

void Goodbye(unsigned int interval)//interval = 50 ---> 1ms
{
	char data[8], data_new[1], data_old[1];
	//char Tail_10_2_flow_on_data[8][2]={{0x10,0x00},{0x30,0x00},{0x70,0x00},{0xF0,0x00},{0xF0,0x01},{0xF0,0x03},{0xF0,0x07},{0xF0,0x0F}};
	//char Tail_10_2_single_on_data[8][2]={{0x10,0x00},{0x20,0x00},{0x40,0x00},{0x80,0x00},{0x00,0x01},{0x00,0x02},{0x00,0x04},{0x00,0x08}};
	char Tail_10_2_flow_off_data[8][2]={{0x00,0x00},{0x10,0x00},{0x30,0x00},{0x70,0x00},{0xF0,0x00},{0xF0,0x01},{0xF0,0x03},{0xF0,0x07}};

	//char Tail_11_flow_on_data[5][2]={{0x03,0x00},{0x0F,0x00},{0x3F,0x00},{0xFF,0x00},{0xFF,0x03}};
	//char Tail_11_single_on_data[5][2]={{0x03,0x00},{0x0C,0x00},{0x30,0x00},{0xC0,0x00},{0x00,0x03}};
	char Tail_11_flow_off_data[5][2]={{0x00,0x00},{0x03,0x00},{0x0F,0x00},{0x3F,0x00},{0xFF,0x00}};

	//char Tail_3_flow_on_data[5][2]={{0x0C,0x00},{0x3C,0x00},{0xFC,0x00},{0xFC,0x03},{0xFC,0x0F}};
	//char Tail_3_single_on_data[5][2]={{0x0C,0x00},{0x30,0x00},{0xC0,0x00},{0x00,0x03},{0x00,0x0C}};
	char Tail_3_flow_off_data[5][2]={{0x00,0x00},{0x0C,0x00},{0x3C,0x00},{0xFC,0x00},{0xFC,0x03}};

	//char Tail_9_flow_on_data[8][2]={{0x80,0x00},{0xC0,0x00},{0xE0,0x00},{0xF0,0x00},{0xF8,0x00},{0xFC,0x00},{0xFE,0x00},{0xFF,0x00}};
	//char Tail_9_single_on_data[8][2]={{0x80,0x00},{0x40,0x00},{0x20,0x00},{0x10,0x00},{0x00,0x08},{0x00,0x04},{0x00,0x02},{0x00,0x01}};
	char Tail_9_flow_off_data[8][2]={{0x00,0x00},{0x80,0x00},{0xC0,0x00},{0xE0,0x00},{0xF0,0x00},{0xF8,0x00},{0xFC,0x00},{0xFE,0x00}};

	//char Tail_1_flow_on_data[8][2]={{0x00,0x08},{0x00,0x0C},{0x00,0x0E},{0x00,0x0F},{0x80,0x0F},{0xC0,0x0F},{0xE0,0x0F},{0xF0,0x0F}};
	//char Tail_1_single_on_data[8][2]={{0x00,0x08},{0x00,0x04},{0x00,0x02},{0x00,0x01},{0x80,0x00},{0x40,0x00},{0x20,0x00},{0x10,0x00}};
	char Tail_1_flow_off_data[8][2]={{0x00,0x00},{0x00,0x08},{0x00,0x0C},{0x00,0x0E},{0x00,0x0F},{0x80,0x0F},{0xC0,0x0F},{0xE0,0x0F}};

	char Tail_10_2_Channel_num_data[8]={0x24,0x25,0x26,0x27,0x28,0x29,0x2A,0x2B};
	char Tail_11_channel_num_data[5]={0x20,0x22,0x24,0x26,0x28};//2 bytes per write
	char Tail_3_channel_num_data[5]={0x22,0x24,0x26,0x28,0x2A};//2 bytes per write
	char Tail_9_channel_num_data[8]={0x27,0x26,0x25,0x24,0x23,0x22,0x21,0x20};
	char Tail_1_channel_num_data[8]={0x2B,0x2A,0x29,0x28,0x27,0x26,0x25,0x24};

	unsigned int i=0,j;
	char PWM_Step_data[2]={0x80,0xFF}; //level 1, level 2, level 3, level 4

	//***initialize
	data[0]=0x02;	//unlock
	FlexBroadcast(0x61, data, DATA_LENGTH_1);//write 0x02 to 0x61
	//***clear fault
	data[0]=0x03;	//clear fault
	FlexBroadcast(0x60, data, DATA_LENGTH_1);//write 0x03 to 0x60 to clear CLR_POR and CLR_FAULT

	//***enable LUT and set PWM freq
	if(tailGoodbyeFlag)
	{
		data[0]=0x10; //set CONF_EXPEN=1
		data[1]=0xA3;	//set PWM freq = 2000Hz
		FlexWrite(DEV_ADDR_10, 0x56, data, DATA_LENGTH_2, TRUE);//write 0x10 to 0x56 and write 0xA3 to 0x57, to enable LUT and set PWM freq on device 10
		FlexWrite(DEV_ADDR_2, 0x56, data, DATA_LENGTH_2, TRUE);//write 0x10 to 0x56 and write 0xA3 to 0x57, to enable LUT and set PWM freq on device 2
		FlexWrite(DEV_ADDR_11, 0x56, data, DATA_LENGTH_2, TRUE);//write 0x10 to 0x56 and write 0xA3 to 0x57, to enable LUT and set PWM freq on device 11
		FlexWrite(DEV_ADDR_3, 0x56, data, DATA_LENGTH_2, TRUE);//write 0x10 to 0x56 and write 0xA3 to 0x57, to enable LUT and set PWM freq on device 3
		FlexWrite(DEV_ADDR_9, 0x56, data, DATA_LENGTH_2, TRUE);//write 0x10 to 0x56 and write 0xA3 to 0x57, to enable LUT and set PWM freq on device 9
		FlexWrite(DEV_ADDR_1, 0x56, data, DATA_LENGTH_2, TRUE);//write 0x10 to 0x56 and write 0xA3 to 0x57, to enable LUT and set PWM freq on device 1
	}

	//******3rd stage, brightness change from "level X+1" to "level x"****
	j=1;
	do
	{
		if(tailGoodbyeFlag==0)
		{
			break;
		}
		data_new[0]=PWM_Step_data[j-1];

		i=0;
		do //turn on device 9 and device 1 with new PWM value in turn
		{
			if(tailGoodbyeFlag==0)
			{
				break;
			}
			FlexWrite(DEV_ADDR_9, Tail_9_channel_num_data[7-i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			FlexWrite(DEV_ADDR_1, Tail_1_channel_num_data[7-i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			delay(interval);
			i++;
		}while(i<8);

		i=0;
		do //turn on device 11 and device 3 with new PWM value in turn
		{
			if(tailGoodbyeFlag==0)
			{
				break;
			}
			data[0]=data_new[0];
			data[1]=data_new[0];
			FlexWrite(DEV_ADDR_11, Tail_11_channel_num_data[4-i], data, DATA_LENGTH_2, TRUE);//assign new value
			FlexWrite(DEV_ADDR_3, Tail_3_channel_num_data[4-i], data, DATA_LENGTH_2, TRUE);//assign new value
			delay(interval);
			i++;
		}while(i<5);
		i=0;
		do //turn on device 10 and device 2 with new PWM value in turn
		{
			if(tailGoodbyeFlag==0)
			{
				break;
			}
			FlexWrite(DEV_ADDR_10, Tail_10_2_Channel_num_data[7-i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			FlexWrite(DEV_ADDR_2, Tail_10_2_Channel_num_data[7-i], data_new, DATA_LENGTH_1, TRUE);//assign new value
			delay(interval);
			i++;
		}while(i<8);
		j--;
	}while(j>0);

	//***4th turn off all channels from level 1 in turn
	i=0;
	do //turn off device 9 and device 1 in turn
	{
		if(tailGoodbyeFlag==0)
		{
			break;
		}
		FlexWrite(DEV_ADDR_9, 0x50, Tail_9_flow_off_data[7-i], DATA_LENGTH_2, TRUE);//turn off specified channels on device 9
		FlexWrite(DEV_ADDR_1, 0x50, Tail_1_flow_off_data[7-i], DATA_LENGTH_2, TRUE);//turn off specified channels on device 1
		delay(interval);
		i++;
	}while(i<8);
	i=0;
	do //turn off device 11 and device 3 in turn
	{
		if(tailGoodbyeFlag==0)
		{
			break;
		}
		FlexWrite(DEV_ADDR_11, 0x50, Tail_11_flow_off_data[4-i], DATA_LENGTH_2, TRUE);//turn off specified channels on device 11
		FlexWrite(DEV_ADDR_3, 0x50, Tail_3_flow_off_data[4-i], DATA_LENGTH_2, TRUE);//turn off specified channels on device 3
		delay(interval);
		i++;
	}while(i<5);
	i=0;
	do //turn off device 10 and device 2 in turn
	{
		if(tailGoodbyeFlag==0)
		{
			break;
		}
		FlexWrite(DEV_ADDR_10, 0x50, Tail_10_2_flow_off_data[7-i], DATA_LENGTH_2, TRUE);//turn off specified channels on device 10
		FlexWrite(DEV_ADDR_2, 0x50, Tail_10_2_flow_off_data[7-i], DATA_LENGTH_2, TRUE);//turn off specified channels on device 2
		delay(interval);
		i++;
	}while(i<8);
	i=0;

	//***turn off all channels on device 9/1/12/4/10/2
	data[0]=0x00;
	data[0]=0x00;
	FlexWrite(DEV_ADDR_10, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 10
	FlexWrite(DEV_ADDR_2, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 2
	FlexWrite(DEV_ADDR_11, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 11
	FlexWrite(DEV_ADDR_3, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 3
	FlexWrite(DEV_ADDR_9, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 9
	FlexWrite(DEV_ADDR_1, 0x50, data, DATA_LENGTH_2, TRUE);//turn off all used channels on device 1
	i=0;
	//*******5th Stage, reset all channels' PWM value to 0xFF
	do
	{
		data[i]=0xFF;
		i++;
	}while(i<8);
	FlexWrite(DEV_ADDR_10, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 10
	FlexWrite(DEV_ADDR_10, 0x28, data, DATA_LENGTH_4, TRUE);
	FlexWrite(DEV_ADDR_2, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 2
	FlexWrite(DEV_ADDR_2, 0x28, data, DATA_LENGTH_4, TRUE);
	FlexWrite(DEV_ADDR_11, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 11
	FlexWrite(DEV_ADDR_11, 0x28, data, DATA_LENGTH_4, TRUE);
	FlexWrite(DEV_ADDR_3, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 3
	FlexWrite(DEV_ADDR_3, 0x28, data, DATA_LENGTH_4, TRUE);
	FlexWrite(DEV_ADDR_9, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 9
	FlexWrite(DEV_ADDR_9, 0x28, data, DATA_LENGTH_4, TRUE);
	FlexWrite(DEV_ADDR_1, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 1
	FlexWrite(DEV_ADDR_1, 0x28, data, DATA_LENGTH_4, TRUE);
}

void fadeInOUT()
{
    unsigned int i=0;
    char data[8];
	//***unlock
	data[0]=0x02;
	FlexBroadcast(0x61, data, DATA_LENGTH_1); //write 0x02 to 0x60h
	//***clear por and fault
	data[0]=0x03;
	FlexBroadcast(0x60, data, DATA_LENGTH_1); //write 0x03 to 0x61h
	//disable all channels
	data[0]=0x00;
	data[1]=0x00;
	FlexBroadcast(0x50, data, DATA_LENGTH_2); //write 0x00 to 0x50h, 0x51h;
	//***enable LUT and set PWMFREQ as 2000Hz
	data[0]=0x10;
	data[1]=0xA7;
	FlexBroadcast(0x56, data, DATA_LENGTH_2); //write 0x01 to 0x56h
											  //write 0xA7 to 0x57h
	i=0;
	do
	{
		data[i]=0x00;
		i++;
	}while(i<8);
    FlexBroadcast(0x20, data, DATA_LENGTH_8); //write CONF_PWMOUT0 to CONF_PWMOUTT7
    FlexBroadcast(0x28, data, DATA_LENGTH_4); //write CONF_PWMOUT8 to CONF_PWMOUT11
	//enable all channels
	data[0]=0xFF;
	data[1]=0x0F;
	FlexBroadcast(0x50, data, DATA_LENGTH_2); //write 0xFF, Ox0F to 0x50h, 0x51h
    delay(250);//delay 10ms
    i=0;
	do
	{
		if(tailFlowFlag==0)
		{
			break;
		}
		i++;
        data[0]=i;
        data[1]=i;
        data[2]=i;
        data[3]=i;
        data[4]=i;
        data[5]=i;
        data[6]=i;
        data[7]=i;
        FlexBroadcast(0x20, data, DATA_LENGTH_8); //write CONF_PWMOUT0 to CONF_PWMOUTT7
        FlexBroadcast(0x28, data, DATA_LENGTH_4); //write CONF_PWMOUT8 to CONF_PWMOUT11
        delay(250);//delay 5ms
        if(i>200)
        {
            delay(250);//delay 5ms
        }
	}while(i<255);
	if(tailFlowFlag==1)
	{
		delay(25000);//delay 500ms
	}
	do
	{
		if(tailFlowFlag==0)
		{
			break;
		}
		i--;
        data[0]=i;
        data[1]=i;
        data[2]=i;
        data[3]=i;
        data[4]=i;
        data[5]=i;
        data[6]=i;
        data[7]=i;
        FlexBroadcast(0x20, data, DATA_LENGTH_8); //write CONF_PWMOUT0 to CONF_PWMOUTT7
        FlexBroadcast(0x28, data, DATA_LENGTH_4); //write CONF_PWMOUT8 to CONF_PWMOUT11
        delay(500);//delay 10ms
	}while(i>0);
	//disable all channels
	data[0]=0x00;
    data[1]=0x00;
    FlexBroadcast(0x50, data, DATA_LENGTH_2); //write 0x00, Ox00 to 0x50h, 0x51h
	delay(250);//delay 5ms
	//***reset all channels' PWM value to 0xFF
	i=0;
	do
	{
		data[i]=0xFF;
		i++;
	}while(i<8);
	FlexWrite(DEV_ADDR_10, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 10
	FlexWrite(DEV_ADDR_10, 0x28, data, DATA_LENGTH_4, TRUE);
	FlexWrite(DEV_ADDR_2, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 2
	FlexWrite(DEV_ADDR_2, 0x28, data, DATA_LENGTH_4, TRUE);
	FlexWrite(DEV_ADDR_11, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 11
	FlexWrite(DEV_ADDR_11, 0x28, data, DATA_LENGTH_4, TRUE);
	FlexWrite(DEV_ADDR_3, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 3
	FlexWrite(DEV_ADDR_3, 0x28, data, DATA_LENGTH_4, TRUE);
	FlexWrite(DEV_ADDR_9, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 9
	FlexWrite(DEV_ADDR_9, 0x28, data, DATA_LENGTH_4, TRUE);
	FlexWrite(DEV_ADDR_1, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 1
	FlexWrite(DEV_ADDR_1, 0x28, data, DATA_LENGTH_4, TRUE);
	FlexWrite(DEV_ADDR_0, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 0
	FlexWrite(DEV_ADDR_0, 0x28, data, DATA_LENGTH_4, TRUE);
	FlexWrite(DEV_ADDR_4, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 4
	FlexWrite(DEV_ADDR_4, 0x28, data, DATA_LENGTH_4, TRUE);
	FlexWrite(DEV_ADDR_8, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 8
	FlexWrite(DEV_ADDR_8, 0x28, data, DATA_LENGTH_4, TRUE);
	FlexWrite(DEV_ADDR_12, 0x20, data, DATA_LENGTH_8, TRUE);//reset PWM on device 12
	FlexWrite(DEV_ADDR_12, 0x28, data, DATA_LENGTH_4, TRUE);
}

void stopBlink()
{
    char data[8];
	//***unlock
	data[0]=0x02;
	FlexBroadcast(0x61, data, DATA_LENGTH_1); //write 0x02 to 0x60h
	//***clear por and fault
	data[0]=0x03;
	FlexBroadcast(0x60, data, DATA_LENGTH_1); //write 0x03 to 0x61h
	//disable all channels
	data[0]=0x00;
	data[1]=0x00;
	FlexBroadcast(0x50, data, DATA_LENGTH_2); //write 0x00 to 0x50h, 0x51h

	//***turn on device 4 and device 12 and device 2 and device 10 stop
	data[0]=0xC0;
	data[1]=0x03;
	data[2]=0x3C;
	data[3]=0x0F;
	FlexWrite(DEV_ADDR_12, 0x50, data+2, DATA_LENGTH_1, TRUE);
	FlexWrite(DEV_ADDR_4, 0x50, data, DATA_LENGTH_2, TRUE);
	FlexWrite(DEV_ADDR_2, 0x50, data+3, DATA_LENGTH_1, TRUE);
	FlexWrite(DEV_ADDR_10, 0x50, data+3, DATA_LENGTH_1, TRUE);
	if(tailFlowFlag==1)
	{
		delay(20000);//delay 400ms
	}
	//***turn off device 2/4 and device 10/12 stop
	data[0]=0x00;
	data[1]=0x00;
	FlexWrite(DEV_ADDR_12, 0x50, data, DATA_LENGTH_1, TRUE);
	FlexWrite(DEV_ADDR_4, 0x50, data, DATA_LENGTH_2, TRUE);
	FlexWrite(DEV_ADDR_2, 0x50, data, DATA_LENGTH_1, TRUE);
	FlexWrite(DEV_ADDR_10, 0x50, data, DATA_LENGTH_1, TRUE);
	if(tailFlowFlag==1)
	{
		delay(20000);//delay 400ms
	}
}

void drlBlink()
{
    char data[8];
	//***unlock
	data[0]=0x02;
	FlexBroadcast(0x61, data, DATA_LENGTH_1); //write 0x02 to 0x60h
	//***clear por and fault
	data[0]=0x03;
	FlexBroadcast(0x60, data, DATA_LENGTH_1); //write 0x03 to 0x61h
	//disable all channels
	data[0]=0x00;
	data[1]=0x00;
	FlexBroadcast(0x50, data, DATA_LENGTH_2); //write 0x00 to 0x50h, 0x51h

	//***turn on device 3/4/11/12 DRL
	data[0]=0x03;
	data[1]=0x0C;
	FlexWrite(DEV_ADDR_12, 0x50, data, DATA_LENGTH_1, TRUE);
	FlexWrite(DEV_ADDR_11, 0x51, data+1, DATA_LENGTH_1, TRUE);
	FlexWrite(DEV_ADDR_4, 0x51, data+1, DATA_LENGTH_1, TRUE);
	FlexWrite(DEV_ADDR_3, 0x50, data, DATA_LENGTH_1, TRUE);
	if(tailFlowFlag==1)
	{
		delay(20000);//delay 400ms
	}
	//***turn off device 4 and device 12 stop
	data[0]=0x00;
	data[1]=0x00;
	FlexWrite(DEV_ADDR_12, 0x50, data, DATA_LENGTH_1, TRUE);
	FlexWrite(DEV_ADDR_11, 0x51, data, DATA_LENGTH_1, TRUE);
	FlexWrite(DEV_ADDR_4, 0x51, data, DATA_LENGTH_1, TRUE);
	FlexWrite(DEV_ADDR_3, 0x50, data, DATA_LENGTH_1, TRUE);
	if(tailFlowFlag==1)
	{
		delay(20000);//delay 400ms
	}
}

void setGlobalDC()
{
    unsigned int i=0;
    char data[8];
	//***unlock
	data[0]=0x00;
	FlexBroadcast(0x61, data, DATA_LENGTH_1); //write 0x00 to 0x61h
	//***clear por and fault
	data[0]=0x03;
	FlexBroadcast(0x60, data, DATA_LENGTH_1); //write 0x03 to 0x60h
	//disable all channels
	data[0]=0x00;
	data[1]=0x00;
	FlexBroadcast(0x50, data, DATA_LENGTH_2); //write 0x00 to 0x50h, 0x51h
	//change all devices' DC to half
//	i=0;
	//do
//	{
	//	data[i]=30;
	//	i++;
//	}while(i<8);
//	FlexBroadcast(0x00, data, DATA_LENGTH_8); //write DC to 0x00h, 0x07h
//	FlexBroadcast(0x08, data, DATA_LENGTH_4); //write DC to 0x08h, 0x0Bh
	//device 3, OUT0/1/6/7/8/9, DC ---> 20
	//device 11, OUT4/5/6/7/10/11, DC ---> 20
	//device 4, OUT10/11, DC --->20
	//device 12 OUT0/1, DC ---> 20
	i=0;
	do
	{
		data[i]=20;
		i++;
	}while(i<4);
	FlexWrite(DEV_ADDR_3, 0x06, data, DATA_LENGTH_4, TRUE);//device 3's OUT6/7/8/9 DC = 20
	FlexWrite(DEV_ADDR_3, 0x00, data, DATA_LENGTH_2, TRUE);//device 3's OUT0/1 DC = 20
	FlexWrite(DEV_ADDR_11, 0x04, data, DATA_LENGTH_4, TRUE);//device 11's OUT4/5/6/7 DC = 20
	FlexWrite(DEV_ADDR_11, 0x0A, data, DATA_LENGTH_2, TRUE);//device 11's OUT10/11 DC = 20
	FlexWrite(DEV_ADDR_4, 0x0A, data, DATA_LENGTH_2, TRUE);//device 4's OUT10/11 DC = 20
	FlexWrite(DEV_ADDR_12, 0x00, data, DATA_LENGTH_2, TRUE);//device 12's OUT0/1 DC = 20
	//device 0/8, OUT0 to 11, DC = 15
	i=0;
	do
	{
		data[i]=15;
		i++;
	}while(i<8);
	FlexWrite(DEV_ADDR_0, 0x00, data, DATA_LENGTH_8, TRUE);
	FlexWrite(DEV_ADDR_0, 0x08, data, DATA_LENGTH_4, TRUE);
	FlexWrite(DEV_ADDR_8, 0x00, data, DATA_LENGTH_8, TRUE);
	FlexWrite(DEV_ADDR_8, 0x08, data, DATA_LENGTH_4, TRUE);
	//***lock
	data[0]=0x0F;
	FlexBroadcast(0x61, data, DATA_LENGTH_1); //write 0x0F to 0x61h
}
