/*
 * kbi.c
 *
 *  Created on: Oct 16, 2019
 *      Author: a0222913
 */

#include "derivative.h" /* include peripheral declarations SSKEAZ64M4 */
#include "BeaconTorch.h"

void kbiInitial()
{
	GPIOB_PDDR &=~((1)+(1<<1)+(1<<2)+(1<<3)); /*set PTE0, PTE1, PTE2, PTE3 as intput */
	GPIOB_PIDR &=~((1)+(1<<1)+(1<<2)+(1<<3));/*PTE0, PTE1, PTE2, PTE3 pins are configured for General Purpose Input, provided the pin is configured for any digital function*/
	SIM_SCGC |= SIM_SCGC_KBI1_MASK; /*Enable bus clock in KBI1*/
	KBI1_SC &= ~KBI_SC_KBIE_MASK; /*Mask keyboard interrupt*/
	KBI1_SC &= ~KBI_SC_KBMOD_MASK; /*Keyboard only detects edges*/
	KBI1_ES |= 0x0F; /*Detect rising edge*/
	KBI1_PE |= 0x0F; /*Pin 0/1/2/3 are enabled as KBI interrupt*/
	KBI1_SC |= KBI_SC_KBACK_MASK;/*Clear any false interrupt*/
	KBI1_SC |= KBI_SC_KBIE_MASK;/*enable interrupt*/
	Enable_Interrupt(KBI1_IRQn);/*Enable UART0 interrupt*/
}

void KBI1_IRQHandler() /* KBI1 interrupt*/
{
	KBI1_SC &= ~KBI_SC_KBIE_MASK; /*Mask keyboard interrupt*/
	KBI1_SC |= KBI_SC_KBACK_MASK;/*Clear any false interrupt*/
	//if(KBI1_SP & KBI_SP_SP(0x01)>>0)
	demoEngine(KBI1_SP & KBI_SP_SP(0x0F));/*identify the clicked button num*/
	KBI1_SC |= KBI_SC_KBACK_MASK;/*Clear any false interrupt*/
	KBI1_SC |= KBI_SC_KBIE_MASK;/*enable interrupt*/
}
